#include "BinarySearchTree.h"

BinSearchNodeEntry nodeArray[50];	// ڵ
int count = 0;	// ڵ

int main(int argc, char* argv[])
{
	PBinSearchTree pTree; // ָ
	
	//
	// ʼؼ
	//
	KeyType Key[] = {18, 73, 10, 10, 5, 4, 6, 99, 27, 41, 51, 45, 32, 25, 54};
	int Length = sizeof(Key)/sizeof(Key[0]);
	
	//
	// 
	//
	CreateSearchTree(&pTree, Key, Length);

	//
	// 
	//	
		
	OutputResult(&pTree);
		
	//
	// ٶ
	//
	DeleteTree(pTree);
	
	return 0;
}

/*
ܣ
	ڶ Key ΪؼĽڵ㡣


	pTree -- ָָ롣
	Key -- ؼ롣
	position -- ڵָָͣڷĽڵָ롣
  
ֵ
	 Key ΪؼĽڵ㷵 1򷵻 0 
*/
int Search(PBinSearchTree* pTree, KeyType Key, PBinSearchNode* position)
{

	//
	// TODO: ڴӴ
	//
	
}

/*
ܣ
	ڵ㡣


	Key -- ؼ롣
  
ֵ
	ڵָ롣	
*/
BinSearchNode* CreateNode(KeyType Key)
{
	BinSearchNode* pNode = (PBinSearchNode)malloc(sizeof(BinSearchNode));
	
	pNode->Key = Key;
	pNode->lchild = NULL;
	pNode->rchild = NULL;
	
	return pNode;
}

/*
ܣ
	


	pTree -- ָָ롣
	Key -- ؼ
	Length -- 鳤ȡ
  
ֵ
	ɹ 1
	ʧܷ 0 
*/
int CreateSearchTree(PBinSearchTree* pTree, KeyType* Key, int Length)
{
	int i;						     // α
	*pTree = NULL;				     // ʼָ
	PBinSearchNode pNode, position;  // ڵָ
	
	
	//
	// TODO: ڴӴ
	//
	
	return 0;
}

/*
ܣ
	ٶ


	pTree -- ָ롣
  
ֵ
	
*/
void DeleteTree(PBinSearchTree pTree)
{
	//
	// õݹʵֺ㷨
	//
	if(pTree != NULL)
	{	
		DeleteTree(pTree->lchild);
		DeleteTree(pTree->rchild);
		
		free(pTree);
	}
}



/*
ܣ
	ȡڵ㡣ʹõݹʵ



	pTree -- ڵĵַ
	nLevel -- ڵڵĲ㼶ڵΪ 1
	nodeType -- ڵ
	flag -- ṹݵĶ

ֵ
	ݵַıʽԼɹ 1򣬷 0
*/
int  CopyNode(PBinSearchTree *pTree, int nLevel, TreeNodeType nodeType, int flag)
{
	int temp1, temp2;
	int i;

	// ݹ
	if(NULL == *pTree)
		return 1;
	i = count;
	nodeArray[i].node.Key = (*pTree)->Key;
	nodeArray[i].node.lchild = (*pTree)->lchild;
	nodeArray[i].node.rchild = (*pTree)->rchild;
	nodeArray[i].nodeExtra.enumType = nodeType;
	nodeArray[i].nodeExtra.nLevel = nLevel;
	nodeArray[i].nodeExtra.flag = flag;
	
	++count;
	
	temp2 = temp1 = flag;
	if(nodeType == TREE_ROOT)
		temp1 = flag;
	else if (flag == 0)
		temp1 = nodeType == TREE_LEFT ? (flag + 1) << 1 : flag << 1;
	else
		temp1 = flag << 1;

	temp2 = temp1;
	// ݹӺҺ
	if(!CopyNode(&(nodeArray[i].node.lchild), nLevel+1, TREE_LEFT, temp1))
		return 0;
	
	if(!CopyNode(&(nodeArray[i].node.rchild), nLevel+1, TREE_RIGHT, temp2))
		return 0;

	return 1;
}

/*
ܣ
	


	pTree -- ָ롣
  
ֵ
	
*/

void OutputResult(PBinSearchTree* pTree)
{
	int i, flag, deep, j;
	if(CopyNode(pTree, 1, TREE_ROOT, 0) == 0)
	{
		printf("ʧ\n");
		return;
	}
	
	for(i = 0; i < count; i++)
	{
		flag = nodeArray[i].nodeExtra.flag;
		deep = nodeArray[i].nodeExtra.nLevel - 1;
		

		for(j=deep-1; j>0; j--)
		{
			if(flag & (1 << j))
				printf(" |   ");
			else if(deep > 1)
				printf("     ");
		}
		if(deep > 0)
			printf(" +---");
		
		printf("%2d ",nodeArray[i].node.Key);
		switch (nodeArray[i].nodeExtra.enumType)
		{
		case TREE_LEFT:
			printf("-L");
			break;
		case TREE_RIGHT:
			printf("-R");
			break;
		case TREE_ROOT:
		default:
			;
		}	
		printf("\n");
	}
}


